; Header File
; Created 20/03/2005; 13:36:44
my_tsr:
; <- a4 pointe vers la structure de l'Event - ne doit pas tre modifi !
; <- a5 pointe vers la jump table
 lea     data_multiclip(pc),a6

 move.w  _tsr_multclip_id(pc),d0
 cmp.w   #UTSR_ABOUT,(a4)
 bne     \about
 cmp.w   2(a4),d0
 bne     \about
 lea      about_str(pc),a0
 move.l  a0,8(a4)
\about:
 cmp.w   #UTSR_KERNEL_UNINSTALL,(a4)
 beq     _alltsr_efface_clips
 cmp.w   #UTSR_DELETE,(a4)
 bne     \delete
 cmp.w   2(a4),d0;TSRId du tsr  effacer
 beq     _alltsr_efface_clips
\delete:
 cmp.w   #UTSR_FORMAT,(a4)
 bne     \format
 cmp.w   2(a4),d0
 beq     _all_tsr_format
\format:
 cmp.w   #UTSR_CMD_000,(a4)
 bne     \cmd000
 cmp.w   2(a4),a0
 beq     _all_tsr_cmd_000
\cmd000:

 cmp.w   #1,2(a6);MultiClip inactif
 beq     \exit
 cmp.w   #CM_KEYPRESS,(a4)
 bne     \keypress
 move.w  10(a4),d0
; cmp.w   #$200+'x',d0;ALT + X
; beq     _alltsr_efface_clips
 cmp.w   #CUT,d0;12288
 beq     _all_tsr_cut
 cmp.w   #COPY,d0;24576
 beq     _all_tsr_copy
 cmp.w   #PASTE,d0;8456
 beq     _all_tsr_paste

\keypress:
 cmp.w   #CM_MENU_CUT,(a4);CM_MENU_CUT
 beq     _all_tsr_cut
 cmp.w   #CM_MENU_COPY,(a4);CM_MENU_COPY
 beq     _all_tsr_copy
 cmp.w   #CM_MENU_PASTE,(a4);CM_MENU_PASTE
 beq     _all_tsr_paste
\exit:
_alltsr_exit:
 rts

;***********************************************************************************************************************
;****                                                                                                               ****
;****                             PARTIE MULTICLIPBOARD                                                             ****
;****                                                                                                               ****
;***********************************************************************************************************************
_all_tsr_cmd_000:
 move.w  8(a4),d0
 bsr     deref
 move.l  a0,d1
 beq     _alltsr_exit
 moveq   #0,d1
\loop:
 addq.w  #1,d1
 tst.b   (a0)+
 bne     \loop
 subq.w  #1,d1
 lea     12(a6),a2
 move.l  #'TEXT',-4(a2)
 move.l  d1,(a2)
 move.w  d0,4(a2)
 bra     _all_tsr_add_to_clipboard


_all_tsr_format:
;bon l faut demander le nombre maximum de handles
;aucun 0, infini 1, 5, 10, 15, 20
 clr.w   -(a7)
 pea     multiclip_str(pc)
 movea.l 276(a5),a0;PopupNew
 jsr     (a0)
 addq.l  #6,a7
 move.w  d0,d4
 beq     _alltsr_exit
 
 moveq   #3,d0
 lea     format_str_00(pc),a0
 bsr     menu_folder_popupaddtext
 moveq   #2,d0
 lea     format_str_0(pc),a0
 bsr     menu_folder_popupaddtext
 moveq   #1,d0
 lea     format_str_1(pc),a0
 bsr     menu_folder_popupaddtext

 lea     format_str_data(pc),a2
 moveq   #9,d3
\loop:
 lea     format_str_2(pc),a0
 move.w  (a2)+,(a0)
 move.w  (a2)+,d0
 bsr     menu_folder_popupaddtext
 dbra    d3,\loop
 bsr     popupdo 
 tst.w   d0
 beq     \skip
 cmp.w   #3,d0
 beq     \free
 move.w  d0,2(a6)

\skip:
 move.w  d4,d0
 bsr     free
 bsr     _all_tsr_tronque
 rts
\free:
 bsr     _alltsr_efface_clips
 bra     \skip
_all_tsr_tronque:
 cmp.w   #2,2(a6)
 ble     _exit
;maintenant on va supprimer les handles en trop
_loop_maxi:
 move.w  (a6),d0
 beq     _exit
 bsr     deref
 moveq   #0,d0
 move.w  (a0),d0
 cmp.w   2(a6),d0
 blt     _exit
 lsl.w   #2,d0
 move.w  0(a0,d0.l),d2
 sub.l   #$00010004,(a0)
 moveq   #0,d0
 move.w  2(a0),d0
 move.w  (a6),d1
 bsr     realloc
 move.w  d2,d0
 bsr     free
 bra     _loop_maxi
_exit:
 rts

;CUT / COPY
_all_tsr_copy:
_all_tsr_cut:
 moveq   #0,d0
 move.l  776(a5),a0;CB_fetchTEXT
 move.w  2(a0),d0
 move.l  d0,a2
_all_tsr_add_to_clipboard:
;-4(a2).l='TEXT'
;(a2).l=taille du clipboard
;4(a2).w=handle du clipboard
 cmp.l   #'TEXT',-4(a2)
 bne     _all_tsr_add_from_clipboard
 tst.l   (a2)
 beq     _all_tsr_add_from_clipboard
 tst.w   4(a2)
 beq     _all_tsr_add_from_clipboard
 bra     _all_tsr_add
_all_tsr_add_from_clipboard:
;on va regarder s'il n'y a pas quand mme un handle avec plein de trucs dedans
; si c'est le cas, c'est qu'auparavant, on a essay de copier un truc vide
 move.w  (a6),d0
 beq     _alltsr_exit
 bsr     deref
 
 bra     _alltsr_exit

_all_tsr_add:
 tst.w   (a6)
 bne     _all_tsr_720_alreadyhdle
 moveq   #6,d0
 bsr     alloc
 move.w  d0,(a6)
 tst.w   d0
 beq     _alltsr_exit
 bsr     deref
 moveq   #4,d0
 move.l  d0,(a0)
_all_tsr_720_alreadyhdle:
 move.w  (a6),d0
 bsr     deref
 moveq   #0,d0
 move.w  2(a0),d0
 move.w  (a6),d1
 addq.w  #4,d0
 bsr     realloc
 tst.w   d0
 beq     _alltsr_exit
 move.w  d0,d4;handle liste clipboards
 moveq   #6,d0
 bsr     alloc
 move.w  d0,d2
 beq     _alltsr_exit
 
 move.w  d4,d0
 bsr     deref
 moveq   #0,d0
 move.w  2(a0),d0
 add.l   #$00010004,(a0)
 move.l  (a2),d1
 move.w  d2,0(a0,d0.l)
 move.w  d1,2(a0,d0.l)
 move.w  4(a2),d0
 bsr     swap_hdles;on va pas tout changer les handles, a serait pas propre

 clr.l   -4(a2);indique que le clipboiard est vide
 clr.l   (a2)

 bsr     _all_tsr_tronque
 bra     _alltsr_exit


; PASTE
_all_tsr_paste:
 tst.w   (a6);le multiclipboard n'est pas activ
 beq     _alltsr_exit
 moveq   #0,d0
 move.l  776(a5),a0;CB_fetchTEXT
 move.w  2(a0),d0
 move.l  d0,a2
 cmp.l   #'TEXT',-4(a2)
 bne    \dontskip
 tst.w   4(a2)
 beq     \dontskip
 tst.l   (a2)
 beq     \dontskip
 bra     \skip
\dontskip:
; l il faut regarder s'il y a pas au moins un handle sauv

\skip:
;menu_folder_popupaddtext:
;a0.l ptr vers txt
;d0.w # du choix
;d4.w handle popup

 clr.w   -(a7)
 pea     multiclip_str(pc)
 movea.l 276(a5),a0;PopupNew
 jsr     (a0)
 addq.l  #6,a7
 move.w  d0,d4
 beq     _alltsr_exit
 move.w  4(a2),d0
 beq     _all_tsr_722_0
 move.l  (a2),d2
 beq     _all_tsr_722_0
 moveq   #1,d3
 bsr     _all_tsr_722_sub
_all_tsr_722_0:
 move.w  (a6),d0
 bsr     deref
 moveq   #0,d5
 move.w  (a0),d5
 beq     _all_tsr_722_efface
 subq.w  #1,d5
_all_tsr_722_loop_0:
 move.w  (a6),d0
 bsr     deref
 move.l  d5,d0
 lsl.l   #2,d0
 move.w  6(a0,d0.l),d2
 move.w  4(a0,d0.l),d0
 bsr     _all_tsr_722_sub
 dbra    d5,_all_tsr_722_loop_0

 clr.w   -(a7)
 moveq   #-1,d0
 move.l  d0,-(a7)
 move.w  d4,-(a7)
 move.l  284(a5),a0;PopupDo
 jsr     (a0)
 addq.l  #8,a7

 move.w  4(a2),d2
 cmp.w   d2,d0
 beq     _all_tsr_722_efface
 tst.w   d0
 beq     _all_tsr_722_erreur
 bsr     swap_hdles
;d0 est le handle choisi
 move.w  d0,d1
 move.w  (a6),d0
 bsr     deref
 move.w  (a0),d0
 subq.w  #1,d0
 addq.l  #4,a0
_all_tsr_722_loop_1:
 cmp.w   (a0)+,d1
 beq     _all_tsr_722_1
 addq.l  #2,a0
 dbra    d0,_all_tsr_722_loop_1
_all_tsr_722_1:
 moveq   #0,d0
 move.w  (a0),d0
 move.l  (a2),d1
 move.l  d0,(a2)
 move.w  d1,(a0)
 move.l  #'TEXT',-4(a2)
_all_tsr_722_efface:
 move.w  d4,d0
 bsr     free;on libre le handle du popup
 bra     _alltsr_exit
_all_tsr_722_erreur:
 move.w  #CM_IDLE,(a4)
 bra     _all_tsr_722_efface
 
 
_all_tsr_722_sub:
;d0.w handle du texte
;d4.w handle popup
;d2.w longueur du texte
 tst.w   d2
 beq     _all_tsr_722_sub_end
 bsr     deref
 lea     8(a6),a1
 moveq   #17,d1
 cmp.w   #18,d2
 bge     _all_tsr_722_sub_loop
 move.w  d2,d1
 subq.w  #1,d1
_all_tsr_722_sub_loop:
 move.b  (a0)+,(a1)+
 dbra    d1,_all_tsr_722_sub_loop
 clr.b   (a1)
 lea     8(a6),a0
 bsr     menu_folder_popupaddtext
 addq.l  #1,d3
_all_tsr_722_sub_end:
 clr.b   8(a6)
 rts
_alltsr_efface_clips0:
 bsr     _alltsr_efface_clips
 pea     clipboard_empty_str(pc)
 move.l  920(a5),a0;ST_help
 jsr     (a0)
 addq.l  #4,a7
 bra     _alltsr_exit
_alltsr_efface_clips:
 move.w  (a6),d0
 beq     _alltsr_efface_clip_end
 bsr     deref
 moveq   #0,d1
 move.w  (a0),d1
 beq     _alltsr_efface_clip_en
 subq.w  #1,d1
 moveq   #0,d2
_alltsr_efface_clips_loop:
 move.w  (a6),d0
 bsr     deref
 move.w  4(a0,d2.l),d0
 bsr     free
 addq.l  #4,d2
 dbra    d1,_alltsr_efface_clips_loop
_alltsr_efface_clip_en:
 move.w  (a6),d0
 bsr     free
 clr.w   (a6)
_alltsr_efface_clip_end:
 rts
;***********************************************************************************************************************
;****                                                                                                               ****
;****                             FIN MULTICLIPBOARD                                                                ****
;****                                                                                                               ****
;***********************************************************************************************************************
;***********************************************************************************************************************
;****                                                                                                               ****
;****                             FIN SETUP                                                                         ****
;****                                                                                                               ****
;***********************************************************************************************************************
data_multiclip:
 ds.w    1;handle multiclip   0
 ds.w    1;nombre  retenir   2
 ds.w    1;
 ds.b    30;                  8
about_str:
 dc.b    'MultiClip 2.00  Flanker',0
format_str_00:
 dc.b    'Librer la mmoire',0
format_str_0:
 dc.b    'Illimit',0
format_str_1:
 dc.b    'Dsactiv',0
 even
format_str_data:
 dc.w    ' 5',5
 dc.w    '10',10
 dc.w    '20',20
 dc.w    '30',30
 dc.w    '40',40
 dc.w    '50',50
 dc.w    '60',60
 dc.w    '70',70
 dc.w    '80',80
 dc.w    '90',90
format_str_2:
 dc.b    ' 5 Blocs',0
 even