; Header File
; Created 28/05/2004; 12:08:47


utsrlib::utsr_install  equ utsrlib@0000
;*****************************************************************************************************************************
; utsrlib::install_tsr(void * code, longint size, int num_func, void * functions)
;******************************************************************************************************************************
;
;
;******************************************************************************************************************************

;*****************************************************************************************************************************
; tsrlib::install_ev_hook
;******************************************************************************************************************************
;
; input :
;   a0.l =  pointeur vers la fonction Event hook  installer    //  pointer to the Event Hook function to install
;   a1.l =  pointeur vers le nom du HooK                        //  pointer to the name of the Hook
;   d0.l =  longueur de la fonction                             //  function's length

;
;
; output :
;   d0.w =  TsrID                                               //  handle of the installed Hook (his TsrID)
;   d0.w = 0 en cas d'erreur                                    //  in case of error 
; d1.w = 1     pas assez de mmoire                             //  not enough memory
; d1.w = 2    Le TSR est dj install                          //  TSR already installed
; d1.w = 3    Le TSR comporte des relogements interdits         //  TSR has relocations which are not allowed
;
; La fonction Event Hook doit avoir le prototype C suivant : void EventHook(EVENT *event)
; The Event Hook function must be a function with this C prototype : void EventHook(EVENT *event)
;******************************************************************************************************************************

utsrlib::utsr_delete equ utsrlib@0001
;*****************************************************************************************************************************
; tsrlib::is_present
;******************************************************************************************************************************
;
; input :
;   a0.l =  pointeur vers le nom du HooK                        //  pointer to the name of the Hook
;
;
; output :
;   d0.w =  TsrID                                               //  handle of the installed Hook (his TsrID)
;   d0.w = 0   Le TSR n'est pas install                        //  this TSR is not installed
;
;******************************************************************************************************************************

;les paramtres passs sur la pile ne sont pas dtruits

utsrlib::utsr_is_present equ utsrlib@0002
;HANDLE UTSR_Id utsrlib@0002(char * utsr_name)
utsrlib::get_utsr_handle equ utsrlib@0003
